package oop2_dat2_u;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class Main
{

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        // Aufgabe 1
        System.out.println("##### AUFGABE 1 #####");
        // Stack initialisieren
        StackArrayList myStack = new StackArrayList<String>();

        /* Stack Test mit "manuellem" pop
        myStack.push("Hallo Du");
        myStack.push("Das ist ein Test");
        myStack.push("LIFO, ich bin das 3. Element und werde als erstes ausgeben...");
        
        System.out.println("POP #1: " + myStack.pop());
        System.out.println("POP #2: " + myStack.pop());
        System.out.println("POP #3: " + myStack.pop());
        if ( ! myStack.isEmpty()) {
        System.out.println("POP #4: " + myStack.pop());
        }
         */

        // Stack neue Elemente einfügen und mittels while ausgeben
        myStack.push("Das");
        myStack.push("ist");
        myStack.push("ein");
        myStack.push("Test");
        myStack.push(";-)");
        // Stack ausgeben
        int i = 0;
        while ( ! myStack.isEmpty()) {
            i ++;
            System.out.println("POP #" + i + ": " + myStack.pop());
        }


        // Aufgabe 2
        System.out.println("\n\n\n##### AUFGABE 2 #####");
        // Queue / Ringbuffer Test
        Ringbuffer myRing = new Ringbuffer(10);
        myRing.enqueue("Queue Test");
        myRing.enqueue("Bla bla bla");
        myRing.enqueue("Test ende...");

        // Queue ausgeben
        while (myRing.getNumberElements() > 0) {
            System.out.println("Queue: " + myRing.dequeue());
        }


        // Aufgabe 3
        System.out.println("\n\n\n##### AUFGABE 3 #####");
        // Doppeltverkette Liste
        MyLinkedList<String> stringList;
        stringList = new MyLinkedList<String>();

        stringList.insert("Die Ersten werden die Letzten sein ;-)");
        stringList.insert("zwei zwei");
        stringList.insert("333");
        stringList.insert("Die Letzten werden die Ersten sein :D");

        System.out.println("> In der Liste sind " + stringList.size() + " Elemente.");

        System.out.println("\n> stringList ausgeben:");
        stringList.print();

        System.out.println("\n> stringList rückwärts ausgeben:");
        stringList.printReverse();

        System.out.println("\n> Gibt es das Element '333'? " + stringList.isFound("333"));
        System.out.println("> Den String '333' entfernen...");
        stringList.remove("333");
        System.out.println("> Gibt es das Element '333'? " + stringList.isFound("333"));
        System.out.println("> stringList ausgeben:");
        stringList.print();
    }
}
